diff -urN firefox-146.0.1-orig/browser/components/urlbar/UrlbarView.sys.mjs firefox-146.0.1/browser/components/urlbar/UrlbarView.sys.mjs
--- firefox-146.0.1-orig/browser/components/urlbar/UrlbarView.sys.mjs	2025-12-18 01:38:42 +0900
+++ firefox-146.0.1/browser/components/urlbar/UrlbarView.sys.mjs	2026-01-14 16:18:07 +0900
@@ -1425,24 +1425,18 @@
   }
 
   #createRowContent(item) {
-    // The url is the only element that can wrap, thus all the other elements
-    // are child of noWrap.
-    let noWrap = this.#createElement("span");
-    noWrap.className = "urlbarView-no-wrap";
-    item._content.appendChild(noWrap);
-
     let favicon = this.#createElement("img");
     favicon.className = "urlbarView-favicon";
-    noWrap.appendChild(favicon);
+    item._content.appendChild(favicon);
     item._elements.set("favicon", favicon);
 
     let typeIcon = this.#createElement("span");
     typeIcon.className = "urlbarView-type-icon";
-    noWrap.appendChild(typeIcon);
+    item._content.appendChild(typeIcon);
 
     let tailPrefix = this.#createElement("span");
     tailPrefix.className = "urlbarView-tail-prefix";
-    noWrap.appendChild(tailPrefix);
+    item._content.appendChild(tailPrefix);
     item._elements.set("tailPrefix", tailPrefix);
     // tailPrefix holds text only for alignment purposes so it should never be
     // read to screen readers.
@@ -1458,6 +1452,20 @@
     tailPrefix.appendChild(tailPrefixChar);
     item._elements.set("tailPrefixChar", tailPrefixChar);
 
+    let url = this.#createElement("span");
+    url.className = "urlbarView-url";
+    item._content.appendChild(url);
+    item._elements.set("url", url);
+
+    let noWrap = this.#createElement("span");
+    noWrap.className = "urlbarView-no-wrap";
+    item._content.appendChild(noWrap);
+
+    let titleSeparator = this.#createElement("span");
+    titleSeparator.className = "urlbarView-title-separator";
+    noWrap.appendChild(titleSeparator);
+    item._elements.set("titleSeparator", titleSeparator);
+
     let title = this.#createElement("span");
     title.classList.add("urlbarView-title", "urlbarView-overflowable");
     noWrap.appendChild(title);
@@ -1468,20 +1476,10 @@
     noWrap.appendChild(tagsContainer);
     item._elements.set("tagsContainer", tagsContainer);
 
-    let titleSeparator = this.#createElement("span");
-    titleSeparator.className = "urlbarView-title-separator";
-    noWrap.appendChild(titleSeparator);
-    item._elements.set("titleSeparator", titleSeparator);
-
     let action = this.#createElement("span");
     action.className = "urlbarView-action";
     noWrap.appendChild(action);
     item._elements.set("action", action);
-
-    let url = this.#createElement("span");
-    url.className = "urlbarView-url";
-    item._content.appendChild(url);
-    item._elements.set("url", url);
   }
 
   /**
diff -urN firefox-146.0.1-orig/browser/themes/shared/urlbarView.css firefox-146.0.1/browser/themes/shared/urlbarView.css
--- firefox-146.0.1-orig/browser/themes/shared/urlbarView.css	2025-12-18 01:38:41 +0900
+++ firefox-146.0.1/browser/themes/shared/urlbarView.css	2026-01-14 20:15:17 +0900
@@ -206,7 +206,7 @@
 
 .urlbarView-no-wrap {
   max-width: 100%;
-  flex-grow: 0;
+  flex-grow: 1;
   flex-shrink: 0;
 
   .urlbarView[action-override] .urlbarView-row[has-url] > .urlbarView-row-inner > &,
@@ -298,14 +298,6 @@
   direction: ltr !important;
 }
 
-.urlbarView-url:-moz-locale-dir(rtl) {
-  /* .urlbarView-url can grow due to `flex-grow: 1`, so without `text-align:
-     right`, the URL text would be left-aligned within .urlbarView-url for RTL
-     due to the `direction: ltr` rule.  .urlbarView-title does not have this
-     problem since it does not have flex. */
-  text-align: right;
-}
-
 /* Favicon */
 
 .urlbarView-favicon {
@@ -689,6 +681,7 @@
 /* Action labels */
 
 .urlbarView-action {
+  display: none;
   white-space: nowrap;
 
   .urlbarView-title:not(:empty) ~ & {
@@ -833,7 +826,7 @@
 /* URLs */
 
 .urlbarView-url {
-  flex-grow: 1;
+  flex-grow: 0;
   flex-shrink: 1;
   font-size: var(--urlbarView-small-font-size);
   /* Increase line-height to avoid cutting overhanging glyphs due to masking on
